      subroutine initialize(ider,diff,dt) 
! this sets up the derivative operator (in F-space) ider.
! 2 pi -> dx * nx  
      implicit none
      include 'param.f90'   
      integer*4 k1,j1,i,j,k,offk 
      complex ider(nx/2+1,ny,nz_max,3)
      complex diff(nx/2+1,ny,nz_max)
      real dt
      do i=1,nx/2+1
         ider(i,:,:,1)= (i-1.)*(0.,1.)/(dx*nx/(2.*pi))
         diff(i,:,:)=diff(i,:,:)-abs(ider(i,:,:,1))**2.19*6.17314e13/nu/2.
      enddo
      do j=1,ny
         j1=j
         if (j .gt. (ny+1)/2) j1=j-ny 
         ider(:,j,:,2)= (j1-1)*(0.,1.)/(dy*ny/(2.*pi))
         diff(:,j,:)=diff(:,j,:)-abs(ider(:,j,:,2))**2.19*6.17314e13/nu/2.
      enddo
! semi explicit scheme
      diff=(exp(diff(:,:,:)*nu*2*dt)-1.)/(2.*dt)
      end subroutine initialize


!=====================================================================
      function ddx(datain)
      implicit none
      include 'param.f90' 
       complex datain(nx/2+1,ny,nz_max),ddx(nx/2+1,ny,nz_max)
      include 'terms3d.f90' 
      ddx=datain*ider(:,:,:,1)
      return
      end function ddx
!=====================================================================
      function ddy(datain)
      implicit none
      include 'param.f90'
      complex datain(nx/2+1,ny,nz_max),ddy(nx/2+1,ny,nz_max)
      include 'terms3d.f90' 
      ddy=datain*ider(:,:,:,2)
      return
      end function ddy
