!================================================================
subroutine derivs(PE,KE)
  ! Calculates RHS
  implicit none     
  include 'param.f90'
  include 'terms3d.f90'           
  include 'functionlist.f90'
  complex fdtemp(nx/2+1,ny,nz_max,nvar)
  real temprho(nx,ny),tempbx(nx,ny),tempby(nx,ny),dt2(nx,ny,3)
  real  norm,PE,KE,PE1,KE1,fac
  integer i,j,k,n,flow_flag
  parameter(norm=1./float(nx*ny)) 
  !FFT IS NOT NORMALIZED  
  fdtemp=fd

  ! dr -> RS
  call sfftw_execute(plan_f2rd_1)
  call sfftw_execute(plan_f2rd_2)
  call sfftw_execute(plan_f2rd_3)
  call sfftw_execute(plan_f2rd_4)
  call sfftw_execute(plan_f2rd_5)
  call sfftw_execute(plan_f2rd_6)
  fd=fdtemp
  rd=rd*norm
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Diagnostics -- not real energies
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  PE1=sum(rd(:,:,:,3)*coeff(:,:,:,1))
  KE1=sum((rd(:,:,:,4)**2+rd(:,:,:,5)**2+rd(:,:,:,6)**2)*coeff(:,:,:,1))
  KE=KE1
  PE=PE1
!!!!FIRST FIND THE EULERIAN DENSITY PERTURBATION!!!!!!!!!!!!!!!
  ! rho_0 dr :RS
  rvtemp(:,:,:,1)=coeff(:,:,:,1)*rd(:,:,:,1)
  rvtemp(:,:,:,2)=coeff(:,:,:,1)*rd(:,:,:,2)
  rvtemp(:,:,:,3)=coeff(:,:,:,1)*rd(:,:,:,3)
  ! d/dz(rho_0 dr_z) :RS 
  rvtemp(:,:,:,3)=0
  ! rho_0 dr_x, rho_0 dr_y -> FS
  call sfftw_execute(plan_r2fvtemp_1)
  call sfftw_execute(plan_r2fvtemp_2)
  !  call sfftw_execute(plan_r2fvtemp_3)
!!!!! NOW STORE FD/dens in fdtemp 
  !  fdtemp=fvtemp 
  ! d/dx(rho_0 dr_x) :FS
  fvtemp(:,:,:,1)=ddx(fvtemp(:,:,:,1))
  ! d/dy(rho_0 dr_y) :FS       
  fvtemp(:,:,:,2)=ddy(fvtemp(:,:,:,2))
  ! d/dx(rho_0 dr_x) ->RS
  call sfftw_execute(plan_f2rvtemp_1)
  rvtemp(:,:,:,1)=rvtemp(:,:,:,1)*norm
  ! d/dy(rho_0 dr_y) ->RS
  call sfftw_execute(plan_f2rvtemp_2)
  rvtemp(:,:,:,2)=rvtemp(:,:,:,2)*norm
  rrho=-(rvtemp(:,:,:,1)+rvtemp(:,:,:,2)+rvtemp(:,:,:,3))


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!NEXT FIND THE EULERIAN PRESSURE PERTURBATION!!!!!!!!!!!!
  ! again at edge
  !(GAMMA_1 P_0/rho_0) rho_1 + (GAMMA_1 P_0 Grad(rho_0)/rho_0 - Grad(P_0)) dr :RS  
!WORK most of noise is in rvtemp(:,:,:,3)
  rPress= coeff(:,:,:,5)*rrho  &
       &   +coeff(:,:,:,6)*rd(:,:,:,1)&
       &   +coeff(:,:,:,7)*rd(:,:,:,2)&
       &   +coeff(:,:,:,8)*rd(:,:,:,3)
  !-------------------------------------------------------------
  !-------------------dB-----------------------------------------
  !
  ! dB=curl{(dx) cross B_0}
  !first calculate (dx) cross B_0 in real space
  rvtemp(:,:,:,1)= rd(:,:,:,2)*coeff(:,:,:,17)&
       &          -rd(:,:,:,3)*coeff(:,:,:,16)
  rvtemp(:,:,:,2)= rd(:,:,:,3)*coeff(:,:,:,15)&
       &          -rd(:,:,:,1)*coeff(:,:,:,17)
  rvtemp(:,:,:,3)= rd(:,:,:,1)*coeff(:,:,:,16)&
       &          -rd(:,:,:,2)*coeff(:,:,:,15)

  ! next calculate dB
  call sfftw_execute(plan_r2fvtemp_1)
  call sfftw_execute(plan_r2fvtemp_2)
  call sfftw_execute(plan_r2fvtemp_3)
  !------x component-----------------  
  fdb(:,:,:,1)=ddy(fvtemp(:,:,:,3))
  call sfftw_execute(plan_f2rdb_1)
  rdb(:,:,:,1)= rdb(:,:,:,1)*norm-0
  !------y component----------------- 
  fdb(:,:,:,2)=-ddx(fvtemp(:,:,:,3))
  call sfftw_execute(plan_f2rdb_2)
  rdb(:,:,:,2)= rdb(:,:,:,2)*norm+0
  !------z component-----------------  
  fdb(:,:,:,3)=ddx(fvtemp(:,:,:,2))-ddy(fvtemp(:,:,:,1))
  call sfftw_execute(plan_f2rdb_3)
  rdb(:,:,:,3)= rdb(:,:,:,3)*norm

  !Copy to Fourier space (only)
  call sfftw_execute(plan_r2frho)
  call sfftw_execute(plan_r2fpress)
  call sfftw_execute(plan_r2fdb_1)
  call sfftw_execute(plan_r2fdb_2)
  call sfftw_execute(plan_r2fdb_3)

!!!rho fixed
  !==========================================================
  !-------------------------------------------
  !----------------dJ-------------------------
  fdJ(:,:,:,1)=ddy(fdB(:,:,:,3))
  call sfftw_execute(plan_f2rdJ_1)
  rdJ(:,:,:,1)=rdJ(:,:,:,1)*norm-0
  !-----y component---------------
  fdJ(:,:,:,2)=-ddx(fdB(:,:,:,3))
  call sfftw_execute(plan_f2rdJ_2)
  rdJ(:,:,:,2)=rdJ(:,:,:,2)*norm+0
  !-----z component------------- 
  fdJ(:,:,:,3)=ddx(fdB(:,:,:,2))-ddy(fdB(:,:,:,1))
  call sfftw_execute(plan_f2rdJ_3)
  rdJ(:,:,:,3)=rdJ(:,:,:,3)*norm

  !-----------------------------------------------
  !-----------Next the Lorentz force--------------
  !first calculate (dJ) cross B_0 in real space
  rLor(:,:,:,1)= rdJ(:,:,:,2)*coeff(:,:,:,17)&
       &        -rdJ(:,:,:,3)*coeff(:,:,:,16)
  rLor(:,:,:,2)= rdJ(:,:,:,3)*coeff(:,:,:,15)&
       &        -rdJ(:,:,:,1)*coeff(:,:,:,17)
  rLor(:,:,:,3)= rdJ(:,:,:,1)*coeff(:,:,:,16)&
       &        -rdJ(:,:,:,2)*coeff(:,:,:,15)
  !next add calculate (J_0) cross dB in real space
  rLor(:,:,:,1)=rLor(:,:,:,1)+&
       & coeff(:,:,:,19)*rdb(:,:,:,3)-coeff(:,:,:,20)*rdb(:,:,:,2)
  rLor(:,:,:,2)=rLor(:,:,:,2)+&
       &coeff(:,:,:,20)*rdb(:,:,:,1)-coeff(:,:,:,18)*rdb(:,:,:,3)
  rLor(:,:,:,3)=rLor(:,:,:,3)+&
       &coeff(:,:,:,18)*rdb(:,:,:,2)-coeff(:,:,:,19)*rdb(:,:,:,1)


  !CGS normalization
  rlor=rlor/(4.*3.1415926535)
  !Scale Lorentz force above photosphere
! kinematic
!  rLor=0
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!NO FLOW!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  flow_flag=0
  if(flow_flag .eq.1) then
  !---------------------------------------------------------------------------
  !------------------------Calculate dU---------------------------------------
  ! U'= d/dt dr + (U_0 . nabla ) dr - (dr . nabla) U_0

  !first x_component
  ! + (U_0 . nabla ) dr
  !calculate d/dx_i rd_j  and move into real space
  fvtemp(:,:,:,1)=ddx(fd(:,:,:,1))
  fvtemp(:,:,:,2)=ddy(fd(:,:,:,1))
  call sfftw_execute(plan_f2rvtemp_1)
  call sfftw_execute(plan_f2rvtemp_2)
  rvtemp(:,:,:,1:2)=rvtemp(:,:,:,1:2)*norm
  rvtemp(:,:,:,3)=0
  rdu(:,:,:,1)=rdu(:,:,:,1)+coeff(:,:,:,21)*rvtemp(:,:,:,1) &
       &                     +coeff(:,:,:,22)*rvtemp(:,:,:,2) &
       &                     +coeff(:,:,:,23)*rvtemp(:,:,:,3) 
  ! - (dr . nabla ) U_0
  rdu(:,:,:,1)=rdu(:,:,:,1)-(rd(:,:,:,1))*coeff(:,:,:,24)&
       &                     -(rd(:,:,:,2))*coeff(:,:,:,27)&
       &                     -(rd(:,:,:,3))*coeff(:,:,:,30)
  !end x_component
  ! second y_component
  ! + (U_0 . nabla ) dr
  !calculate d/dx_i rd_j  and move into real space
  fvtemp(:,:,:,1)=ddx(fd(:,:,:,2))
  fvtemp(:,:,:,2)=ddy(fd(:,:,:,2))
  call sfftw_execute(plan_f2rvtemp_1)
  call sfftw_execute(plan_f2rvtemp_2)
  rvtemp(:,:,:,1:2)=rvtemp(:,:,:,1:2)*norm
  rvtemp(:,:,:,3)=0
  rdu(:,:,:,2)=rdu(:,:,:,2)+coeff(:,:,:,21)*rvtemp(:,:,:,1) &
       &                   +coeff(:,:,:,22)*rvtemp(:,:,:,2) &
       &                   +coeff(:,:,:,23)*rvtemp(:,:,:,3) 
  ! - (dr . nabla ) U_0
  rdu(:,:,:,2)=rdu(:,:,:,2)-rd(:,:,:,1)*coeff(:,:,:,25)&
       &                   -rd(:,:,:,2)*coeff(:,:,:,28)&
       &                   -rd(:,:,:,3)*coeff(:,:,:,31)
  !end y_component
  !third z_component
  ! + (U_0 . nabla ) dr
  !calculate d/dx_i rd_j  and move into real space
  fvtemp(:,:,:,1)=ddx(fd(:,:,:,3))
  fvtemp(:,:,:,2)=ddy(fd(:,:,:,3))
  call sfftw_execute(plan_f2rvtemp_1)
  call sfftw_execute(plan_f2rvtemp_2)
  rvtemp(:,:,:,1:2)=rvtemp(:,:,:,1:2)*norm
  rvtemp(:,:,:,3)=0
  rdu(:,:,:,3)=rdu(:,:,:,3)+coeff(:,:,:,21)*rvtemp(:,:,:,1) &
       &                     +coeff(:,:,:,22)*rvtemp(:,:,:,2) &
       &                     +coeff(:,:,:,23)*rvtemp(:,:,:,3) 
  ! - (dr . nabla ) U_0
  rdu(:,:,:,3)=rdu(:,:,:,3)-rd(:,:,:,1)*coeff(:,:,:,26)&
       &                     -rd(:,:,:,2)*coeff(:,:,:,29)&
       &                     -rd(:,:,:,3)*coeff(:,:,:,32)
  !end z_component

  !copy into fourier space as well 
  call sfftw_execute(plan_r2fdU_1)
  call sfftw_execute(plan_r2fdU_2)
  call sfftw_execute(plan_r2fdU_3)
  !---------------------------------------------------------------------------
  !----------------------Calculate the force due to U_0-----------------------
  !rinertia=[ -(U_0 . nabla) d/dt(dr) - (U_0 . nabla) dU 
  !           +([d/dt(dr) -drho U_0/rho_0 -dU].nabla) U_0]

  !x-component
  !-(U_0 . nabla) (d/dt(dr))
  fvtemp(:,:,:,1)=ddx(fd(:,:,:,4))
  fvtemp(:,:,:,2)=ddy(fd(:,:,:,4))
  call sfftw_execute(plan_f2rvtemp_1)
  call sfftw_execute(plan_f2rvtemp_2)
  rvtemp(:,:,:,1:2)=rvtemp(:,:,:,1:2)*norm
  rvtemp(:,:,:,3)=0
  rinertia(:,:,:,1)=-coeff(:,:,:,21)*rvtemp(:,:,:,1)&
       &            -coeff(:,:,:,22)*rvtemp(:,:,:,2) &
       &            -coeff(:,:,:,23)*rvtemp(:,:,:,3) 
  !-(U_0 . nabla) dU
  fvtemp(:,:,:,1)=ddx(fdU(:,:,:,1))
  fvtemp(:,:,:,2)=ddy(fdU(:,:,:,1))
  call sfftw_execute(plan_f2rvtemp_1)
  call sfftw_execute(plan_f2rvtemp_2)
  rvtemp(:,:,:,1:2)=rvtemp(:,:,:,1:2)*norm
  rvtemp(:,:,:,3)=0
  rinertia(:,:,:,1)=rinertia(:,:,:,1)-coeff(:,:,:,21)*rvtemp(:,:,:,1)&
       &                             -coeff(:,:,:,22)*rvtemp(:,:,:,2)&
       &                             -coeff(:,:,:,23)*rvtemp(:,:,:,3) 

  !+(d/dt(dr) . nabla) U_0]

  rinertia(:,:,:,1)=rinertia(:,:,:,1)&
       &               +(rd(:,:,:,4))*coeff(:,:,:,24)&
       &               +(rd(:,:,:,5))*coeff(:,:,:,27)&
       &               +(rd(:,:,:,6))*coeff(:,:,:,30)

  !+([ -drho U_0/rho_0 -dU].nabla) U_0]
  rvtemp(:,:,:,1)=-rrho*coeff(:,:,:,33)-rdU(:,:,:,1)
  rvtemp(:,:,:,2)=-rrho*coeff(:,:,:,34)-rdU(:,:,:,2)
  rvtemp(:,:,:,3)=-rrho*coeff(:,:,:,35)-rdU(:,:,:,3)

  rinertia(:,:,:,1)=rinertia(:,:,:,1)+rvtemp(:,:,:,1)*coeff(:,:,:,24)&
       &                             +rvtemp(:,:,:,2)*coeff(:,:,:,27)&
       &                             +rvtemp(:,:,:,3)*coeff(:,:,:,30)
  !------------------------END X-----------------------------------------
  !y-component
  !-(U_0 . nabla) d/dt(dr)
  fvtemp(:,:,:,1)=ddx(fd(:,:,:,5))
  fvtemp(:,:,:,2)=ddy(fd(:,:,:,5))
  call sfftw_execute(plan_f2rvtemp_1)
  call sfftw_execute(plan_f2rvtemp_2)
  rvtemp(:,:,:,1:2)=rvtemp(:,:,:,1:2)*norm
  rvtemp(:,:,:,3)=0
  rinertia(:,:,:,2)=-coeff(:,:,:,21)*rvtemp(:,:,:,1)&
       &            -coeff(:,:,:,22)*rvtemp(:,:,:,2) &
       &            -coeff(:,:,:,23)*rvtemp(:,:,:,3) 
  !-(U_0 . nabla) dU
  fvtemp(:,:,:,1)=ddx(fdU(:,:,:,2))
  fvtemp(:,:,:,2)=ddy(fdU(:,:,:,2))
  call sfftw_execute(plan_f2rvtemp_1)
  call sfftw_execute(plan_f2rvtemp_2)
  rvtemp(:,:,:,1:2)=rvtemp(:,:,:,1:2)*norm
  rvtemp(:,:,:,3)=0
  rinertia(:,:,:,2)=rinertia(:,:,:,2)-coeff(:,:,:,21)*rvtemp(:,:,:,1)&
       &                             -coeff(:,:,:,22)*rvtemp(:,:,:,2)&
       &                             -coeff(:,:,:,23)*rvtemp(:,:,:,3) 
  !+(d/dt(dr) . nabla) U_0]
  rinertia(:,:,:,2)=rinertia(:,:,:,2)&
       &                   +(rd(:,:,:,4))*coeff(:,:,:,25)&
       &                   +(rd(:,:,:,5))*coeff(:,:,:,28)&
       &                   +(rd(:,:,:,6))*coeff(:,:,:,31)

  !+([-drho U_0/rho_0 -dU].nabla) U_0]
  rvtemp(:,:,:,1)=-rrho*coeff(:,:,:,33)-rdU(:,:,:,1)
  rvtemp(:,:,:,2)=-rrho*coeff(:,:,:,34)-rdU(:,:,:,2)
  rvtemp(:,:,:,3)=-rrho*coeff(:,:,:,35)-rdU(:,:,:,3)
  rinertia(:,:,:,2)=rinertia(:,:,:,2)+rvtemp(:,:,:,1)*coeff(:,:,:,25)&
       &                             +rvtemp(:,:,:,2)*coeff(:,:,:,28)&
       &                             +rvtemp(:,:,:,3)*coeff(:,:,:,31)
  !------------------------END y-----------------------------------------
  !z-component
  !-(U_0 . nabla) d/dt(dr)
  fvtemp(:,:,:,1)=ddx(fd(:,:,:,6))
  fvtemp(:,:,:,2)=ddy(fd(:,:,:,6))
  call sfftw_execute(plan_f2rvtemp_1)
  call sfftw_execute(plan_f2rvtemp_2)
  rvtemp(:,:,:,1:2)=rvtemp(:,:,:,1:2)*norm
  rvtemp(:,:,:,3)=0
  rinertia(:,:,:,3)=-coeff(:,:,:,21)*rvtemp(:,:,:,1)&
       &            -coeff(:,:,:,22)*rvtemp(:,:,:,2)&
       &            -coeff(:,:,:,23)*rvtemp(:,:,:,3) 
  !-(U_0 . nabla) dU
  fvtemp(:,:,:,1)=ddx(fdU(:,:,:,3))
  fvtemp(:,:,:,2)=ddy(fdU(:,:,:,3))
  call sfftw_execute(plan_f2rvtemp_1)
  call sfftw_execute(plan_f2rvtemp_2)
  rvtemp(:,:,:,1:2)=rvtemp(:,:,:,1:2)*norm
  rvtemp(:,:,:,3)=0
  rinertia(:,:,:,3)=rinertia(:,:,:,3)-coeff(:,:,:,21)*rvtemp(:,:,:,1)&
       &                             -coeff(:,:,:,22)*rvtemp(:,:,:,2)&
       &                             -coeff(:,:,:,23)*rvtemp(:,:,:,3) 
  !+(d/dt(dr) . nabla) U_0]
  rinertia(:,:,:,3)=rinertia(:,:,:,3)&
       &                     +(rd(:,:,:,4))*coeff(:,:,:,26)&
       &                     +(rd(:,:,:,5))*coeff(:,:,:,29)&
       &                     +(rd(:,:,:,6))*coeff(:,:,:,32)    

  !+([-drho U_0/rho_0 -dU].nabla) U_0]
  rvtemp(:,:,:,1)=-rrho*coeff(:,:,:,33)-rdU(:,:,:,1)
  rvtemp(:,:,:,2)=-rrho*coeff(:,:,:,34)-rdU(:,:,:,2)
  rvtemp(:,:,:,3)=-rrho*coeff(:,:,:,35)-rdU(:,:,:,3)
  rinertia(:,:,:,3)=rinertia(:,:,:,3)+rvtemp(:,:,:,1)*coeff(:,:,:,26)&
       &                             +rvtemp(:,:,:,2)*coeff(:,:,:,29)&
       &                             +rvtemp(:,:,:,3)*coeff(:,:,:,32)  
  !------------------------END z-----------------------------------------
 
  !========================END U_0 force stuff==============================

 endif !!!!!!!!!!END FLOW!!!!!!!!!!!!!!!!!!!!


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!NEXT FIND d/dt (drdot)
  !-d/dx (P) :FS
  fvtemp(:,:,:,1)=-ddx(fpress)
  !-d/dy (P) :FS
  fvtemp(:,:,:,2)=-ddy(fPress)       
  !-d/dz (P) :RS
  rvtemp(:,:,:,3)=0
  !d/dx (P), d/dy (P) ->RS
  call sfftw_execute(plan_f2rvtemp_1)
  call sfftw_execute(plan_f2rvtemp_2)
  rvtemp(:,:,:,1)=rvtemp(:,:,:,1)*norm
  rvtemp(:,:,:,2)=rvtemp(:,:,:,2)*norm
  drddt(:,:,:,4)=rvtemp(:,:,:,1)*coeff(:,:,:,12)  &
       &     +rLor(:,:,:,1)*coeff(:,:,:,12)            &
       &     +rInertia(:,:,:,1)
  drddt(:,:,:,5)=rvtemp(:,:,:,2)*coeff(:,:,:,12)  &
       &     +rLor(:,:,:,2)*coeff(:,:,:,12)            &
       &     +rinertia(:,:,:,2)
  drddt(:,:,:,6)=rvtemp(:,:,:,3)*coeff(:,:,:,12)  &
       &     +rLor(:,:,:,3)*coeff(:,:,:,12)            &
       &     +rinertia(:,:,:,3)                        &
       &          +rrho*coeff(:,:,:,13)

  call sfftw_execute(plan_r2fddt_4)
  call sfftw_execute(plan_r2fddt_5)
  call sfftw_execute(plan_r2fddt_6)


end subroutine derivs
