!=======================================================================
subroutine initfftw()
  implicit none
  include 'param.f90'
  include 'terms3d.f90'
  !  Setup all the ffts.
  include 'fftw3.f' 
  integer *4   nn(2),nxny,one,nnc(2),nxnyc
!   call sfftw_init_threads()
!   call sfftw_plan_with_nthreads(1)
  one=1
  nn(1)=nx
  nn(2)=ny
  nnc(1)=nx/2+1
  nnc(2)=ny
  nxny=nx*ny 
  nxnyc=(nx/2+1)*ny
  ! setup forward plan
  call sfftw_plan_many_dft_r2c(plan_r2fd_1,2,nn,nz,                   &
       rd(:,:,1:nz,1),nn,one,nxny,                                       &
       fd(:,:,1:nz,1),nnc,one,nxnyc,                                     &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fd_2,2,nn,nz,                   &
       rd(:,:,1:nz,2),nn,one,nxny,                                       &
       fd(:,:,1:nz,2),nnc,one,nxnyc,                                     &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fd_3,2,nn,nz,                   &
       rd(:,:,1:nz,3),nn,one,nxny,                                       &
       fd(:,:,1:nz,3),nnc,one,nxnyc,                                     &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fd_4,2,nn,nz,                   &
       rd(:,:,1:nz,4),nn,one,nxny,                                       &
       fd(:,:,1:nz,4),nnc,one,nxnyc,                                     &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fd_5,2,nn,nz,                   &
       rd(:,:,1:nz,5),nn,one,nxny,                                       &
       fd(:,:,1:nz,5),nnc,one,nxnyc,                                     &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fd_6,2,nn,nz,                   &
       rd(:,:,1:nz,6),nn,one,nxny,                                       &
       fd(:,:,1:nz,6),nnc,one,nxnyc,                                     &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fvtemp_1,2,nn,nz,               &
       rvtemp(:,:,1:nz,1),nn,one,nxny,                                   &
       fvtemp(:,:,1:nz,1),nnc,one,nxnyc,                                 &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fvtemp_2,2,nn,nz,               &
       rvtemp(:,:,1:nz,2),nn,one,nxny,                                   &
       fvtemp(:,:,1:nz,2),nnc,one,nxnyc,                                 &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fvtemp_3,2,nn,nz,               &
       rvtemp(:,:,1:nz,3),nn,one,nxny,                                   &
       fvtemp(:,:,1:nz,3),nnc,one,nxnyc,                                 &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fpress,2,nn,nz,                 &
       rpress(:,:,1:nz),nn,one,nxny,                                     &
       fpress(:,:,1:nz),nnc,one,nxnyc,                                   &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2frho,2,nn,nz,                 &
       rrho(:,:,1:nz),nn,one,nxny,                                     &
       frho(:,:,1:nz),nnc,one,nxnyc,                                   &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fddt_4,2,nn,nz,                 &
       drddt(:,:,1:nz,4),nn,one,nxny,                                    &
       dfddt(:,:,1:nz,4),nnc,one,nxnyc,                                  &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fddt_5,2,nn,nz,                 &
       drddt(:,:,1:nz,5),nn,one,nxny,                                    &
       dfddt(:,:,1:nz,5),nnc,one,nxnyc,                                  &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fddt_6,2,nn,nz,                 &
       drddt(:,:,1:nz,6),nn,one,nxny,                                    &
       dfddt(:,:,1:nz,6),nnc,one,nxnyc,                                  &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fdB_1,2,nn,nz,                  &
       rdb(:,:,1:nz,1),nn,one,nxny,                                      &
       fdb(:,:,1:nz,1),nnc,one,nxnyc,                                    &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fdB_2,2,nn,nz,                  &
       rdb(:,:,1:nz,2),nn,one,nxny,                                      &
       fdb(:,:,1:nz,2),nnc,one,nxnyc,                                    &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fdB_3,2,nn,nz,                  &
       rdb(:,:,1:nz,3),nn,one,nxny,                                      &
       fdb(:,:,1:nz,3),nnc,one,nxnyc,                                    &
       fftw_measure)

  call sfftw_plan_many_dft_r2c(plan_r2fB0_1,2,nn,nz,                  &
       rb0(:,:,1:nz,1),nn,one,nxny,                                      &
       fb0(:,:,1:nz,1),nnc,one,nxnyc,                                    &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fB0_2,2,nn,nz,                  &
       rb0(:,:,1:nz,2),nn,one,nxny,                                      &
       fb0(:,:,1:nz,2),nnc,one,nxnyc,                                    &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fB0_3,2,nn,nz,                  &
       rb0(:,:,1:nz,3),nn,one,nxny,                                      &
       fb0(:,:,1:nz,3),nnc,one,nxnyc,                                    &
       fftw_measure)

  call sfftw_plan_many_dft_r2c(plan_r2fdJ_1,2,nn,nz,                  &
       rdJ(:,:,1:nz,1),nn,one,nxny,                                      &
       fdJ(:,:,1:nz,1),nnc,one,nxnyc,                                    &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fdJ_2,2,nn,nz,                  &
       rdJ(:,:,1:nz,2),nn,one,nxny,                                      &
       fdJ(:,:,1:nz,2),nnc,one,nxnyc,                                    &
       fftw_measure)
  call sfftw_plan_many_dft_r2c(plan_r2fdJ_3,2,nn,nz,                  &
       rdJ(:,:,1:nz,3),nn,one,nxny,                                      &
       fdJ(:,:,1:nz,3),nnc,one,nxnyc,                                    &
       fftw_measure)
 call sfftw_plan_many_dft_r2c(plan_r2fdU_1,2,nn,nz,                   &
       rdU(:,:,1:nz,1),nn,one,nxny,                                      &
       fdU(:,:,1:nz,1),nnc,one,nxnyc,                                    &
       fftw_measure)
 call sfftw_plan_many_dft_r2c(plan_r2fdU_2,2,nn,nz,                   &
       rdU(:,:,1:nz,2),nn,one,nxny,                                      &
       fdU(:,:,1:nz,2),nnc,one,nxnyc,                                    &
       fftw_measure)
 call sfftw_plan_many_dft_r2c(plan_r2fdU_3,2,nn,nz,                   &
       rdU(:,:,1:nz,3),nn,one,nxny,                                      &
       fdU(:,:,1:nz,3),nnc,one,nxnyc,                                    &
       fftw_measure)
 

  ! setup inverse plans
  call sfftw_plan_many_dft_c2r(plan_f2rd_1,&
       2,nn,nz,                                                       &
       fd(:,:,1:nz,1),nnc,one,nxnyc,                                     &
       rd(:,:,1:nz,1),nn,one,nxny,                                       &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rd_2,2,nn,nz,                   &
       fd(:,:,1:nz,2),nnc,one,nxnyc,                                     &
       rd(:,:,1:nz,2),nn,one,nxny,                                       &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rd_3,2,nn,nz,                   &
       fd(:,:,1:nz,3),nnc,one,nxnyc,                                     &
       rd(:,:,1:nz,3),nn,one,nxny,                                       &
       fftw_measure)

  call sfftw_plan_many_dft_c2r(plan_f2rd_4,2,nn,nz,                   &
       fd(:,:,1:nz,4),nnc,one,nxnyc,                                     &
       rd(:,:,1:nz,4),nn,one,nxny,                                       &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rd_5,2,nn,nz,                   &
       fd(:,:,1:nz,5),nnc,one,nxnyc,                                     &
       rd(:,:,1:nz,5),nn,one,nxny,                                       &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rd_6,2,nn,nz,                   &
       fd(:,:,1:nz,6),nnc,one,nxnyc,                                     &
       rd(:,:,1:nz,6),nn,one,nxny,                                       &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rrho,2,nn,nz,               &
       frho,nnc,one,nxnyc,                                 &
       rrho,nn,one,nxny,                                   &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rvtemp_1,2,nn,nz,               &
       fvtemp(:,:,1:nz,1),nnc,one,nxnyc,                                 &
       rvtemp(:,:,1:nz,1),nn,one,nxny,                                   &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rvtemp_2,2,nn,nz,               &
       fvtemp(:,:,1:nz,2),nnc,one,nxnyc,                                 &
       rvtemp(:,:,1:nz,2),nn,one,nxny,                                   &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rvtemp_3,2,nn,nz,               &
       fvtemp(:,:,1:nz,3),nnc,one,nxnyc,                                 &
       rvtemp(:,:,1:nz,3),nn,one,nxny,                                   &
       fftw_measure)

 call sfftw_plan_many_dft_c2r(plan_f2rpress,2,nn,nz,                 &
       fpress(:,:,1:nz),nnc,one,nxnyc,                                     &
       rpress(:,:,1:nz),nn,one,nxny,                                   &
       fftw_measure)
 

  call sfftw_plan_many_dft_c2r(plan_f2rdb_1,2,nn,nz,               &
       fdb(:,:,1:nz,1),nnc,one,nxnyc,                                 &
       rdb(:,:,1:nz,1),nn,one,nxny,                                   &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rdb_2,2,nn,nz,               &
       fdb(:,:,1:nz,2),nnc,one,nxnyc,                                 &
       rdb(:,:,1:nz,2),nn,one,nxny,                                   &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rdb_3,2,nn,nz,               &
       fdb(:,:,1:nz,3),nnc,one,nxnyc,                                 &
       rdb(:,:,1:nz,3),nn,one,nxny,                                   &
       fftw_measure)

  call sfftw_plan_many_dft_c2r(plan_f2rdJ_1,2,nn,nz,               &
       fdJ(:,:,1:nz,1),nnc,one,nxnyc,                                 &
       rdJ(:,:,1:nz,1),nn,one,nxny,                                   &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rdJ_2,2,nn,nz,               &
       fdJ(:,:,1:nz,2),nnc,one,nxnyc,                                 &
       rdJ(:,:,1:nz,2),nn,one,nxny,                                   &
       fftw_measure)
  call sfftw_plan_many_dft_c2r(plan_f2rdJ_3,2,nn,nz,               &
       fdJ(:,:,1:nz,3),nnc,one,nxnyc,                                 &
       rdJ(:,:,1:nz,3),nn,one,nxny,                                   &
       fftw_measure)

end subroutine initfftw
