subroutine outputcube(fd,rd,rpress,rrho,rdb,time,ol)
  ! write out result
  implicit none
  include 'param.f90'
  integer ol,i
  complex fdin(nx/2+1,ny,nz_max,nvar)
  complex fd(nx/2+1,ny,nz_max,nvar)        
  real   rd(nx,ny,nz_max,nvar),  rpress(nx,ny,nz_max),  rrho(nx,ny,nz_max)
  real   rdb(nx,ny,nz_max,3), rdfull(nx,ny,nz_ghostglobal),temp(nx,ny,nz_max)
  real  time
  character*80 fn,stringol,zeros
   
  write(stringol,*) ol 
  zeros=""
  if (ol .lt. 10000) zeros="_0"
  if (ol .lt. 1000 ) zeros="_00"
  if (ol .lt. 100  ) zeros="_000"
  if (ol .lt. 10   ) zeros="_0000"  
  fn="rd.output."//trim(adjustl(zeros))//trim(adjustl(stringol))    &
       //".fits"
  do i=1,6 
     rdfull=rd(:,:,:,i)
     if(my_rank .eq. 0) then  
     call fw_cube(fn,rdfull,nx,ny,nz_ghostglobal,dx,dy,dz,time,ol,i)
     endif	
  enddo
 end subroutine outputcube
!======================================================================================

subroutine input(ol)
  ! write out result
  implicit none
  include 'param.f90'
  include 'terms3d.f90'
  character*80 fn,comment,err
  character*8 kywrd
  real rdinfull(nx,ny,nz_ghostglobal)
  real rdin(nx,ny,nz_max)
  integer readwrite,group,fpixel,nelements,status,unit,junk
  logical er
  integer i,k,blocksize,ol
  status=0 
  comment="Step number"
  kywrd="STEP"

  fn="IC.fits"
  blocksize=1
  group=1
  fpixel=1	
  readwrite=0
  nelements=nx*ny*nz_ghostglobal
  if(my_rank .eq. 0) then
    call ftgiou(unit,status)
    call ftopen(unit,fn,readwrite,blocksize,status)
  endif	
  do i=1,nvar
     if(my_rank .eq. 0)  then
        call FTMAHD(unit,i,junk,status)
	call ftgpve(unit,group,fpixel,nelements,0.,rdinfull,er,status)
        call ftgkyj(unit,kywrd,ol,comment,status)  
     endif
     rdin=rdinfull
     rd(:,:,:,i)=rdin
  enddo
  if(my_rank .eq. 0) then 
     call ftclos(unit, status)
     call ftfiou(unit, status)
  endif
  if(status .ne. 0) then
	call ftgerr(status,err)
	write(*,*) err
	stop
  endif		



!do fft stuff
  call sfftw_execute(plan_r2fd_1)
  call sfftw_execute(plan_r2fd_2)
  call sfftw_execute(plan_r2fd_3)
  call sfftw_execute(plan_r2fd_4)
  call sfftw_execute(plan_r2fd_5)
  call sfftw_execute(plan_r2fd_6)
end subroutine input

!--------------------------------------------------------




!==========================================================================
! SAVE A CUBE FOR RESTART
!--------------------------------
      subroutine fw_cube(fn,data,nx,ny,nz,dx,dy,dz,time,step,k)
      implicit none	
      character*80 fn
      character*30 errmsg
      real data(nx,ny,nz)
      real dx,dy,dz,time
      integer dx1,dy1,dz1,step,junk
      integer status,unit,blocksize,bitpix,naxis,naxes(3)
      integer i,j,group,fpixel,nelements,nx,ny,nz
      integer n,k
      logical simple,extend

      group=1
      fpixel=1
      simple=.true.
      status=0 
      bitpix=-32
      naxis=3
      naxes(1)=nx
      naxes(2)=ny
      naxes(3)=nz	
      extend=.true.
      status=0
      blocksize=1  
      nelements=naxes(1)*naxes(2)*naxes(3)
      call ftgiou(unit,status)
      if(k .eq. 1) then 
         call ftinit(unit,fn,blocksize,status)
      endif	 
      if(k .ne. 1) then
         call FTOPEN(unit,fn,1,blocksize,status) 
         call FTMAHD(unit,k-1,junk,status)
         call FTCRHD(unit,status) 
      endif	
!     write the required header keywords
      call ftphpr(unit,simple,bitpix,naxis,naxes,0,1,extend,status)
      call ftpkyj(unit,'time',0,'restart time',status)
      call ftpkyj(unit,'step',step,'Step number',status)
      dx1=dx/1e2	
      dy1=dy/1e2
      dz1=dz/1e2	 
      call ftpkyj(unit,'dx',dx1,'m',status)
      call ftpkyj(unit,'dy',dy1,'m',status)
      call ftpkyj(unit,'dz',dz1,'m',status)
!     write the array to the FITS file
      call ftppre(unit,group,fpixel,nelements,data,status)

!     close the file and free the unit number
      call ftclos(unit, status)
      call ftfiou(unit, status)
      if (status .ne. 0) then
	    call ftgerr(status,errmsg)
  	    write(*,*) "err: ", errmsg  
  	    stop	
      endif	
      end subroutine fw_cube



