program makeIC
  ! write out result
  implicit none
  include 'param.f90'
  include 'terms3d.f90'
  integer i,j,k,j1,n,l
  real z,rsun,sigma,kz,omega,a(nz_ghostglobal),amplitude,r,omega_star
  real mask(nx/2+1)
  real data(nx,ny,nz_ghostglobal,nvar)
  real tdata(nx,ny,nz_ghostglobal)

  character*80 fn
  parameter (rsun=6.98e10)
  
  data(50,:,:,1)=100
  data(:,:,:,2)=0 
  data(:,:,:,3)=0 
  data(:,:,:,4)=0 
  data(:,:,:,5)=0
  data(:,:,:,6)=0


  fn="IC.fits" 
  call fw(fn,data,nx,ny,nz_ghostglobal,dx,dy,dz,0.,0) 
  write(*,*) "Success" 
end program makeIC

!============================================================================
      subroutine fr(fn,data,nx,ny,nz)
      implicit none	
      character*80 fn
      character*30 errmsg
      real data(nx,ny,nz), data1(nx,ny,nz)    
      real dx,dy,dz,time
      integer dx1,dy1,dz1,step
      integer status,unit,blocksize,bitpix,naxis,naxes(3)
      integer i,j,group,fpixel,nelements,nx,ny,nz
      integer n,k
      logical simple,extend
      integer readwrite
      logical er

      status=0
      readwrite=0
      blocksize=1
      group=1
      fpixel=1   
      nelements=nx*ny*nz
   
      call ftgiou(unit,status)
      call ftopen(unit,fn,readwrite,blocksize,status)
      call ftgpve(unit,group,fpixel,nelements,0.,data,er,status)
      call ftclos(unit, status)
      call ftfiou(unit, status)
      write(*,*) fn,maxval(data),status 
      if (status .ne. 0) then
	    call ftgerr(status,errmsg)
  	    write(*,*) "err: ", errmsg  
  	    stop	
      endif	
      end subroutine fr
!=============================================================================
      subroutine fw(fn,data,nx,ny,nz,dx,dy,dz,time,step)
      implicit none	
      character*80 fn
      character*30 errmsg
      real data(nx,ny,nz,6), data1(nx,ny,nz)    
      real dx,dy,dz,time
      integer dx1,dy1,dz1,step
      integer status,unit,blocksize,bitpix,naxis,naxes(3)
      integer i,j,group,fpixel,nelements,nx,ny,nz
      integer n,k
      logical simple,extend

      status=0
      blocksize=1
  
      call ftgiou(unit,status)
      
      blocksize=1
      call ftinit(unit,fn,blocksize,status)
      simple=.true.
      bitpix=-32
      naxis=3
      naxes(1)=nx
      naxes(2)=ny
      naxes(3)=nz	
      extend=.true.

!     write the required header keywords
      call ftphpr(unit,simple,bitpix,naxis,naxes,0,1,extend,status)
      call ftpkyj(unit,'time',0,'restart time',status)
      call ftpkyj(unit,'step',step,'Step number',status)
      call ftpkyj(unit,'W-MODE',1,'F mode plane wave',status)
      dx1=dx/1e2	
      dy1=dy/1e2
      dz1=dz/1e2	 
      call ftpkyj(unit,'dx',dx1,'m',status)
      call ftpkyj(unit,'dy',dy1,'m',status)
      call ftpkyj(unit,'dz',dz1,'m',status)

!     write the array to the FITS file
      group=1
      fpixel=1
      nelements=naxes(1)*naxes(2)*naxes(3)
      data1=data(:,:,:,1) 
	write(*,*) k,":",maxval(data1)
      call ftppre(unit,group,fpixel,nelements,data1,status)	
      do k=2,6	
      	data1=data(:,:,:,k)
      	call ftcrhd(unit,status)
      	call ftphpr(unit,simple,bitpix,naxis,naxes,0,1,extend,status)
        call ftpkyj(unit,'time',0,'restart time',status)
        call ftpkyj(unit,'step',step,'Step number',status)
        call ftpkyj(unit,'W-MODE',1,'F mode plane wave',status)
        dx1=dx/1e2	
        dy1=dy/1e2
        dz1=dz/1e2	 
        call ftpkyj(unit,'dx',dx1,'m',status)
        call ftpkyj(unit,'dy',dy1,'m',status)
        call ftpkyj(unit,'dz',dz1,'m',status)
        write(*,*) k,":",maxval(data1)

      	call ftppre(unit,group,fpixel,nelements,data1,status)
      enddo		

!     close the file and free the unit number
      call ftclos(unit, status)
      call ftfiou(unit, status)
      if (status .ne. 0) then
	    call ftgerr(status,errmsg)
  	    write(*,*) "err: ", errmsg  
  	    stop	
      endif	
      end subroutine fw



