program makecoeff
  ! program to make coefficients for helioseismology runs
  implicit none
  include 'comments.f90'
  include 'param.f90'
  real B0(nx,ny,nz_ghostglobal+2,3),U0(nx,ny,nz_ghostglobal+2,3),bztemp(nx,ny,nz_ghostglobal+2,3)
  real pressure(nx,ny,nz_ghostglobal+2),gamma(nx,ny,nz_ghostglobal+2),rho(nx,ny,nz_ghostglobal+2)
  real vtemp(nx,ny,nz_ghostglobal+2,3)
  real coeff(nx,ny,nz_ghostglobal+2,ncoeff)
  !  real*4 coeffout(nx,ny,nz,ncoeff)
  real temp(nx,ny,nz_ghostglobal+2),fac,data(nx,ny,nz_ghostglobal)
  character*80 fn,fnb
  integer k,k1,i,j,n_rec
  interface
     function grad(datain) 
       include 'param.f90'
       real datain(nx,ny,nz_ghostglobal+2),grad(nx,ny,nz_ghostglobal+2,3)
     end function grad
  end interface
  interface
     function ave(datain)
       include 'param.f90'
       real datain(nx,ny,nz_ghostglobal+2),ave(nx,ny,nz_ghostglobal+2,3)
     end function ave
  end interface

!first read in the files

 	
  fn="spot/bx1_wavesim.fits"
  call fr(fn,temp,nx,ny,nz_ghostglobal+2)
  b0(:,:,:,1)=temp
  fn="spot/by1_wavesim.fits"
  call fr(fn,temp,nx,ny,nz_ghostglobal+2)
  b0(:,:,:,2)=temp
  fn="spot/bz1_wavesim.fits"
  call fr(fn,temp,nx,ny,nz_ghostglobal+2)
  b0(:,:,:,3)=temp

  fn="spot/pressure_wavesim.fits"
  call fr(fn,pressure,nx,ny,nz_ghostglobal+2)

  fn="spot/rho_wavesim.fits"
  call fr(fn,rho,nx,ny,nz_ghostglobal+2)

  fn="spot/gamma1_wavesim.fits"
  call fr(fn,gamma,nx,ny,nz_ghostglobal+2)

  fn="spot/ux1_wavesim.fits"
  call fr(fn,temp,nx,ny,nz_ghostglobal+2)
  u0(:,:,:,1)=temp
  fn="spot/uy1_wavesim.fits"
  call fr(fn,temp,nx,ny,nz_ghostglobal+2)
  u0(:,:,:,2)=temp
  fn="spot/uz1_wavesim.fits"
  call fr(fn,temp,nx,ny,nz_ghostglobal+2)
  u0(:,:,:,3)=temp


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  
 ! B0=0
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! next calculate the coefficient array
  coeff(:,:,:,1)=rho
  coeff(:,:,:,2:4)=grad(rho)
  coeff(:,:,:,5)= Gamma * pressure / rho
  coeff(:,:,:,9:11)=Grad(pressure)
  !  coeff(:,:,:,9:10)=0
  !  coeff(:,:,:,11)=-rho *g 
  coeff(:,:,:,6)= Gamma*pressure*coeff(:,:,:,2)/rho -coeff(:,:,:,9)
  coeff(:,:,:,7)= Gamma*pressure*coeff(:,:,:,3)/rho -coeff(:,:,:,10)
  coeff(:,:,:,8)= Gamma*pressure*coeff(:,:,:,4)/rho -coeff(:,:,:,11)
  !  coeff(:,:,:,6)= -coeff(:,:,:,9)
  !  coeff(:,:,:,7)= -coeff(:,:,:,10)
  !  coeff(:,:,:,8)= -coeff(:,:,:,11)
  coeff(:,:,:,12)= 1. / rho
  coeff(:,:,:,13)= g / rho
  coeff(:,:,:,14)= g
  !magnetic field stuff
  coeff(:,:,:,15)= B0(:,:,:,1)
  coeff(:,:,:,16)= B0(:,:,:,2)
  coeff(:,:,:,17)= B0(:,:,:,3)
  vtemp=Grad(B0(:,:,:,1))
  coeff(:,:,:,19)=  vtemp(:,:,:,3)
  coeff(:,:,:,20)= -vtemp(:,:,:,2)
  vtemp=Grad(B0(:,:,:,2))
  coeff(:,:,:,18)= -vtemp(:,:,:,3)
  coeff(:,:,:,20)= coeff(:,:,:,20)+ vtemp(:,:,:,1)
  vtemp=Grad(B0(:,:,:,3))
  coeff(:,:,:,18)= coeff(:,:,:,18)+vtemp(:,:,:,2)
  coeff(:,:,:,19)= coeff(:,:,:,19)-vtemp(:,:,:,1)
  !velocity field stuff
  coeff(:,:,:,21)= U0(:,:,:,1)
  coeff(:,:,:,22)= U0(:,:,:,2)
  coeff(:,:,:,23)= U0(:,:,:,3)
  vtemp=Grad(U0(:,:,:,1))
  coeff(:,:,:,24)= vtemp(:,:,:,1)
  coeff(:,:,:,27)= vtemp(:,:,:,2)
  coeff(:,:,:,30)= vtemp(:,:,:,3)
  vtemp=Grad(U0(:,:,:,2))
  coeff(:,:,:,25)= vtemp(:,:,:,1)
  coeff(:,:,:,28)= vtemp(:,:,:,2)
  coeff(:,:,:,31)= vtemp(:,:,:,3)
  vtemp=Grad(U0(:,:,:,3))
  coeff(:,:,:,26)= vtemp(:,:,:,1)
  coeff(:,:,:,29)= vtemp(:,:,:,2)
  coeff(:,:,:,32)= vtemp(:,:,:,3)

  coeff(:,:,:,33)= U0(:,:,:,1)/rho
  coeff(:,:,:,34)= U0(:,:,:,2)/rho
  coeff(:,:,:,35)= U0(:,:,:,3)/rho
  coeff(:,:,:,36)=Gamma*pressure
  !---------------------
  Bztemp=b0(:,:,:,:)
  where (abs(Bztemp) .lt. 1e-9) Bztemp=1e-9
  !---------------------
  coeff(:,:,:,37)=B0(:,:,:,1)/Bztemp(:,:,:,3)
  coeff(:,:,:,38)=B0(:,:,:,2)/Bztemp(:,:,:,3)
  vtemp(:,:,:,1)=pressure+&
       &     (b0(:,:,:,1)**2+b0(:,:,:,2)**2-b0(:,:,:,3)**2)/(8.*pi)
  coeff(:,:,:,39:41)=Grad(vtemp(:,:,:,1))

  !---------------------
  Bztemp=ave(b0(:,:,:,3))
  where (abs(Bztemp) .lt. 1e-6) Bztemp=1e-6
  !---------------------

  vtemp(:,:,:,1)=B0(:,:,:,1)*B0(:,:,:,3)
  coeff(:,:,:,42:44)=Grad(vtemp(:,:,:,1))
  coeff(:,:,:,42)=coeff(:,:,:,42)/bztemp(:,:,:,1)
  coeff(:,:,:,43)=coeff(:,:,:,43)/bztemp(:,:,:,2)
  coeff(:,:,:,44)=coeff(:,:,:,44)/bztemp(:,:,:,3)
  vtemp(:,:,:,1)=B0(:,:,:,2)*B0(:,:,:,3)
  coeff(:,:,:,45:47)=Grad(vtemp(:,:,:,1))
  coeff(:,:,:,45)=coeff(:,:,:,45)/bztemp(:,:,:,1)
  coeff(:,:,:,46)=coeff(:,:,:,46)/bztemp(:,:,:,2)
  coeff(:,:,:,47)=coeff(:,:,:,47)/bztemp(:,:,:,3)
  coeff(:,:,:,48)=1./bztemp(:,:,:,3)

  !reduce Lorentz force in upper domain.
!do the output
  fnb="coeff_wavesim.fits"
  fn=fnb
  data=coeff(:,:,2:nz_ghostglobal+1,1)
  write(*,*) maxval(data)
  call fw(fn,data,nx,ny,nz_ghostglobal,0) 
  do k=2,ncoeff
	n_rec=k-1
        data=coeff(:,:,2:nz_ghostglobal+1,k)
	if(n_rec .le. 10) write(fn,'(I1)') n_rec-1
	if(n_rec .gt. 10) write(fn,'(I2)') n_rec-1
        fn=trim(fnb)//'+'//trim(fn)
	call  fw(fn,data,nx,ny,nz_ghostglobal,k-1)  
  enddo
  write(*,*) "Success"

end program makecoeff
!!$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function grad(datain)
  implicit none
  include 'param.f90'
  real datain(nx,ny,nz_ghostglobal+2)
  real grad(  nx,ny,nz_ghostglobal+2,3)
  grad(2:nx-1,:,:,1)=(datain(3:nx,:,:)-datain(1:nx-2,:,:))/(2.*dx)
#if threed 
  grad(:,2:ny-1,:,2)=(datain(:,3:ny,:)-datain(:,1:ny-2,:))/(2.*dy)
#endif
  grad(:,:,2:nz_ghostglobal+1,3)=(datain(:,:,3:nz_ghostglobal+2)&
       &                          -datain(:,:,1:nz_ghostglobal))/(2.*dz)
!  grad(:,:,:,3)=0

! x,y and z directions are periodic
  grad( 1,:,:,1)=(datain(2,:,:)-datain(nx  ,:,:))/(2.*dx)
  grad(nx,:,:,1)=(datain(1,:,:)-datain(nx-1,:,:))/(2.*dx)
#if threed 
  grad(:, 1,:,2)=(datain(:,2,:)-datain(:,ny,:  ))/(2.*dy)
  grad(:,ny,:,2)=(datain(:,1,:)-datain(:,ny-1,:))/(2.*dy)
#endif

  grad(:,:, 1,3)=grad(:,:,2,3)
  grad(:,:,nz_ghostglobal+2,3)=grad(:,:,nz_ghostglobal+1,3)


end function grad
!!$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function ave(datain)
  implicit none
  include 'param.f90'
  real datain(nx,ny,nz_ghostglobal+2)
  real ave(  nx,ny,nz_ghostglobal+2,3)
  ave(2:nx-1,:,:,1)=(datain(3:nx,:,:)+datain(1:nx-2,:,:))/(2.)
#if threed 
  ave(:,2:ny-1,:,2)=(datain(:,3:ny,:)+datain(:,1:ny-2,:))/(2.)
#endif
  ave(:,:,2:nz+1,3)=(datain(:,:,3:nz+2)+datain(:,:,1:nz))/(2.)

! x,y and z directions are periodic
  ave( 1,:,:,1)=(datain(2,:,:)+datain(nx  ,:,:))/(2.)
  ave(nx,:,:,1)=(datain(1,:,:)+datain(nx-1,:,:))/(2.)
#if threed 
  ave(:, 1,:,2)=(datain(:,2,:)+datain(:,ny,:  ))/(2.)
  ave(:,ny,:,2)=(datain(:,1,:)+datain(:,ny-1,:))/(2.)
#endif

  ave(:,:, 1,3)=ave(:,:,2,3)
  ave(:,:,nz+2,3)=ave(:,:,nz+1,3)
end function ave
!========================================================================================================================
      subroutine fr(fn,data,nx,ny,nz)
      implicit none	
      integer nx,ny,nz,blocksize	
      character*80 fn
      real data(nx,ny,nz)
      integer readwrite,group,fpixel,nelements,status,unit
      logical er
      character*30 errmsg	

      readwrite=0	
      blocksize=1
      status=0	
      call ftgiou(unit,status)	
      call ftopen(unit,fn,readwrite,blocksize,status)
      group=1
      fpixel=1
      nelements=nx*ny*nz
      call ftgpve(unit,group,fpixel,nelements,0.,data,er,status)
      call ftclos(unit, status)
      call ftfiou(unit, status)

      if(status .ne. 0) then
        call ftgerr(status,errmsg)
        write(*,*) "reading: ",fn
	write(*,*) "readin error: ",status,errmsg
	stop
      endif			
      end subroutine fr	 
!========================================================================================================================
      subroutine fw(fn,data,nx,ny,nz,n_rec)
      implicit none	
      character*80 fn,record,infn
      character*30 errmsg
      real data(nx,ny,nz),alpha,b_0	
      integer status,unit,blocksize,bitpix,naxis,naxes(3)
      integer i,j,group,fpixel,nelements,nx,ny,nz
      integer n,n_rec,readwrite,nkeys,nspace,iunit
      logical simple,extend

      status=0
      write(*,*) n_rec,minval(data),maxval(data)	
!     Get an unused Logical Unit Number to use to create the FITS file
      call ftgiou(unit,status)
      call  ftgiou(iunit,status)
      blocksize=1
      readwrite=1  
      if(n_rec .eq. 0)	then
	call ftinit(unit,fn,blocksize,status)
      else 
	call ftnopn(unit,fn,blocksize,status)
	call ftcrhd(unit,status)
      endif		
      simple=.true.
      bitpix=-32
      naxis=3
      naxes(1)=nx
      naxes(2)=ny
      naxes(3)=nz	
      extend=.true.
      call ftphpr(unit,simple,bitpix,naxis,naxes,0,1,extend,status)

      if (status .ne. 0) then
	call ftgerr(status,errmsg) 
	write(*,*) "error:",errmsg
	stop
      endif	
   !OK now we need to open a data file to retrieve the header information
      call  ftgiou(iunit,status)
      readwrite=0
      infn= "spot/bx1_wavesim.fits"
      call ftopen(iunit,infn,readwrite,blocksize,status)
   !how many key words do we have?
      call ftghsp(iunit,nkeys,nspace,status)
   ! Read each 80-character keyword record, and print it out.
      do i = 9, nkeys
          call ftgrec(iunit,i,record,status)
          call ftprec(unit,record,status)
      enddo
      call ftclos(iunit, status)
      call ftfiou(iunit, status)
!OK HEADER DONE
!     write the array to the FITS file
      group=1
      fpixel=1
      nelements=nx*ny*nz
      call ftppre(unit,group,fpixel,nelements,data,status)	
!make next hdu
      call ftclos(unit, status)
      call ftfiou(unit, status)	
      end subroutine fw



