nx=200
ny=200

bx=fltarr(nx,ny,3)
by=fltarr(nx,ny,3)
bz=fltarr(nx,ny,3)
ux=fltarr(nx,ny,3)
uy=fltarr(nx,ny,3)
uz=fltarr(nx,ny,3)
rho=fltarr(nx,ny,3)
p=fltarr(nx,ny,3)
gamma=fltarr(nx,ny,3)

;The model atmosphere
x=indgen(nx)
y=indgen(ny)

r=fltarr(nx,ny,3)
for i=0,nx-1 do begin
   for j=0,ny-1 do begin
      r(i,j,*)=sqrt((x(i)-100.)^2+(y(j)-100.)^2)
   endfor
endfor   
p_0=184711.
eps=0.9
bz=exp(-r^4/5000.)*sqrt(8*!pi*p_0*eps)

gamma=gamma*0+1.52
p=p*0+p_0-(bx^2+by^2+bz^2)/(8*!pi)
rho_qs=3.44084e-7
T=p(0,0,0)/rho_qs
rho=p/T

fits_write,"./spot/gamma1_wavesim.fits",gamma
fits_write,"./spot/bx1_wavesim.fits",bx
fits_write,"./spot/by1_wavesim.fits",by
fits_write,"./spot/bz1_wavesim.fits",bz
fits_write,"./spot/pressure_wavesim.fits",p
fits_write,"./spot/rho_wavesim.fits",rho
fits_write,"./spot/ux1_wavesim.fits",ux
fits_write,"./spot/uy1_wavesim.fits",uy
fits_write,"./spot/uz1_wavesim.fits",uz
stop
end
