subroutine wave()
  !copyright Robert Cameron. 
  include 'comments.f90'
  implicit none
  include 'param.f90'
  include 'terms3d.f90'
  include 'functionlist.f90'

  real  t,PE,KE,corr,corr2,FSmax,FSmax1,dt1,random_jitter(nx,ny),rn
  complex fdold(nx/2+1,ny,nz_max,nvar)
  integer  i,ol,ol_old,i1,k,n,mark,j,rs,rseed(4),nsamp,ssamp    
  complex fdtemp(nx/2+1,ny,nz_max,nvar)
  complex temp(nx/2+1,ny,nz_max)

  fsmax=0 	
  CALL SETUPcoeff(coeff)
  FSmax1=sqrt(maxval(&
       & (    coeff(:,:,:,15)**2+coeff(:,:,:,16)**2&
       &                                +coeff(:,:,:,17)**2)&
       &                /(4. *3.1415926)*coeff(:,:,:,12)&
       & +coeff(:,:,:,5) &
       & ))
  FSmax=max(FSmax,FSmax1)
  write(*,*) FSmax
  dt=min(dx,dy, dz)/FSmax/4.
  dt=15./(int(15./dt)+1)
  !full cube sample
  nsamp=(30+dt/30.)/(2*dt)
  !     INITIALIZE FOURIER TRANSFORMS and derivative arrays and data
  call initialize(ider,diff,dt)
  call initfftw()
  write(*,*) my_rank,"dt=",dt
  
  CALL input(ol_old)
  !ol_old=ol_old*nsamp
  ol_old=0
  t=ol_old*2*dt
  if (my_rank .eq. 0) write(*,*) "restoring from step:",ol_old, "t=", t
  !     -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  call derivs(PE,KE)
  !stop
  ! the time integration
  do ol=ol_old,10000000   
     dfddt(:,:,:,1)=fd(:,:,:,4)
     dfddt(:,:,:,2)=fd(:,:,:,5)
     dfddt(:,:,:,3)=fd(:,:,:,6)
     call derivs(PE,KE)
     if (mod(ol,nsamp) .eq. 0) then
        mark=ol/nsamp
        if(my_rank .eq. 0) write(*,*) "saving cube",t,mark
        call outputcube(fd,rd,rpress,rrho,rdb,t,mark)
     endif
     if(my_rank .eq. 0) write(*,*) t,PE,KE,ol,nsamp
     fd=fd+(dfddt)*dt  
     t=t+dt
     do i1=1,6
        diffdfddt(:,:,:,i1)=fd(:,:,:,i1)*diff(:,:,:)
     enddo
     fd=fd+diffdfddt*dt
  enddo
  !     =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
end subroutine wave

!================================================================
